/*
 *  exit_if.c
 *  spica_read_0C
 *
 *	This program is used in case an error occurs during the reading 
 *  of a SPICAM or SPICAV 0C file. It prints out the location and code
 *  where the program failed.
 */

#include <stdio.h>
#include <stdlib.h>
#include "exit_if.h"

char *exit_message = NULL;

void exit_if(char *filename, int line, int condition, char *code, char *message)
{
	if (condition == 0)
		return;
	if (message == NULL)
		fprintf(stderr,"%s:%d: stop condition: « %s » \n",filename, line, code);
	else 
		fprintf(stderr, "%s:%d: %s\n", filename, line, message);
	
	exit_message = message;
	exit(EXIT_FAILURE);
}

void perror_and_exit (char *localisation)
{
	perror(localisation);
	exit(EXIT_FAILURE);
}


