/*
 *  spica_read_1A.c
 *
 *  SVN Revision:
 *      $Rev: 937 $
 *      $Author: chapron $
 *      $Date: 2012-12-13 14:12:10 +0100 (jeu., 13 déc. 2012) $
 *
 */

#include "spica_read_1A.h"

int 
main(int argc, char **argv)
{
	// 1A reading parameters
	spica_1Afile File1A;
	char *filename = '\0';
	char *cleandata_sample = '\0';
	char *temperatures_sample = '\0';
	char *georec_sample = '\0';
	char *geosc_sample = '\0';
	char *geoband1_sample = '\0';
	char *geoband2_sample = '\0';
	char *geoband3_sample = '\0';
	char *geoband4_sample = '\0';
	char *geoband5_sample = '\0';
	char *geocoord_sample = '\0';
	char *geotransm_sample = '\0';
	char *geolose_sample = '\0';
	
	// Init
	int check_filename = 0;
	int print_cleandata = 0;
	int print_param = 0;
	int print_info = 0;
	int print_geoinfo = 0;
	int print_min = 0;
	int print_max = 0;
	int print_onlydata = 0;
	int print_temperatures = 0;
	
	// Init array of indices (for option -r and -c): [i0:i3, i1:i4, i2:i5]
	int *cleandata_arr_id = (int *)malloc(6 * sizeof(int));
	int *temperatures_arr_id = (int *)malloc(6 * sizeof(int));
	int *georec_arr_id = (int *)malloc(6 * sizeof(int));
	int *geosc_arr_id = (int *)malloc(6 * sizeof(int));
	int *geoband1_arr_id = (int *)malloc(6 * sizeof(int));
	int *geoband2_arr_id = (int *)malloc(6 * sizeof(int));
	int *geoband3_arr_id = (int *)malloc(6 * sizeof(int));
	int *geoband4_arr_id = (int *)malloc(6 * sizeof(int));
	int *geoband5_arr_id = (int *)malloc(6 * sizeof(int));
	int *geocoord_arr_id = (int *)malloc(6 * sizeof(int));
	int *geotransm_arr_id = (int *)malloc(6 * sizeof(int));
	int *geolose_arr_id = (int *)malloc(6 * sizeof(int));
	
	// getopt_long parameters
	int c;
	
	while (1) {
        int option_index = 0;
        static struct option long_options[] = {
			{"info",		no_argument,		0,	'i' },
			{"cleandata",   optional_argument,	0,	'c' },
			{"geoinfo",		no_argument,		0,	'g' },
			{"georec",		required_argument,	0,	0 },
			{"geosc",		required_argument,	0,	0 },
			{"geoband1",	required_argument,	0,	0 },
			{"geoband2",	required_argument,	0,	0 },
			{"geoband3",	required_argument,	0,	0 },
			{"geoband4",	required_argument,	0,	0 },
			{"geoband5",	required_argument,	0,	0 },
			{"geocoord",	required_argument,	0,	0 },
			{"geotransm",	required_argument,	0,	0 },
			{"geolose",	    required_argument,	0,	0 },
			{"minimum",		no_argument,        0,	'm' },
			{"maximum",		no_argument,	    0,	'M' },
			{"parameters",	no_argument,		0,	'p' },
			{"temperatures",required_argument,	0,	't' },
			{"version",		no_argument,		0,	'v' },
            {0,				0,					0,	0 }
        };
		
		c = getopt_long(argc, argv, "-igmMopvt:rc",
						long_options, &option_index);
		
        if (c == -1)
            break;
		
		
		switch (c) {
			case 0:
				printf("option %s", long_options[option_index].name);
				if (optarg)
					printf(" with arg %s", optarg);
				printf("\n");
				
				if(strcmp(long_options[option_index].name, "georec") == 0)
					georec_sample = optarg;
				if(strcmp(long_options[option_index].name, "geosc") == 0)
					geosc_sample = optarg;
				if(strcmp(long_options[option_index].name, "geoband1") == 0)
					geoband1_sample = optarg;
				if(strcmp(long_options[option_index].name, "geoband2") == 0)
					geoband2_sample = optarg;
				if(strcmp(long_options[option_index].name, "geoband3") == 0)
					geoband3_sample = optarg;
				if(strcmp(long_options[option_index].name, "geoband4") == 0)
					geoband4_sample = optarg;
				if(strcmp(long_options[option_index].name, "geoband5") == 0)
					geoband5_sample = optarg;
				if(strcmp(long_options[option_index].name, "geocoord") == 0)
					geocoord_sample = optarg;
				if(strcmp(long_options[option_index].name, "geotransm") == 0)
					geotransm_sample = optarg;
				if(strcmp(long_options[option_index].name, "geolose") == 0)
					geolose_sample = optarg;
				
				break;
				
			case 1://get filename
				filename=optarg;
				check_filename = 1;
				break;
				
			case 'c':
				cleandata_sample = optarg;
				print_cleandata = 1;
				break;
				
			case 'i':
				print_info = 1;
				break;
				
			case 'g':
				print_geoinfo = 1;
				break;
				
			case 'm':
				print_min = 1;
				break;
				
			case 'M':
				print_max = 1;
				break;
				
			case 'o':
				print_onlydata = 1;
				break;
				
			case 'p':
				print_param = 1;
				break;
				
			case 't':
				temperatures_sample = optarg;
				print_temperatures = 1;
				break;
				
			case 'v':
				printf("Version:1.0\n");
				break;
				
			default:
				printf("?? getopt returned character code 0%o ??\n", c);
        }
    }
	
	if (optind < argc) {
        printf("non-option ARGV-elements: ");
        while (optind < argc)
            printf("%s ", argv[optind++]);
        printf("\n");
	}
	
	
	//Read file
	if(check_filename != 0){
		spica_struct_1A(&File1A,filename,0);
		
		// Infos
		if(print_info == 1){
			printf("#Naxis1:%d\n",File1A.Info.naxis1);
			printf("#Naxis2:%d\n",File1A.Info.naxis2);
			printf("#Naxis3:%d\n",File1A.Info.naxis3);
			printf("#Instrument:%s\n",File1A.Info.instrument);
			printf("#Orbit:%d\n",File1A.Info.orbit);
			printf("#Sequence:%d\n",File1A.Info.seq);
			printf("#Obs.Type:%s\n",File1A.Info.obstype);
			printf("#BeginTime:%s\n",File1A.Info.begins);
			printf("#EndTime:%s\n",File1A.Info.ends);
			printf("#DCProc:%d\n",File1A.Info.DCProc);
			printf("#ENProc:%d\n",File1A.Info.ENProc);
			printf("#COSProc:%d\n",File1A.Info.COSProc);
			printf("#SATProc:%d\n",File1A.Info.SATProc);
			printf("#File0C:%s\n",File1A.Info.File0C);
			printf("#OrbitDCNU:%d\n",File1A.Info.orbDCNU);
			printf("#DATA_SATUS:%s\n",File1A.Info.data_status);
			printf("#GEO_SATUS:%s\n",File1A.Info.geo_status);
			printf("#FLAG_SATUS:%s\n",File1A.Info.flag_status);
			printf("#DC_SATUS:%s\n",File1A.Info.dc_status);
		}
		
		// Parameters
		if(print_param == 1){
			printf("#CodeOp:%d\n",File1A.Parameters.codeop);
			printf("#Binning:%d\n",File1A.Parameters.binning);
			printf("#Ti:%d\n",File1A.Parameters.ti);
			printf("#HT:%d\n",File1A.Parameters.ht);
			printf("#X0:%d\n",File1A.Parameters.x0);
			printf("#Y0:%d\n",File1A.Parameters.y0);
			printf("#Slit:%d\n",File1A.Parameters.slit);
			printf("#Peltier:%d\n",File1A.Parameters.peltier);
			printf("#UVSampling:%d\n",File1A.Parameters.uvsampling);
			printf("#IRON:%d\n",File1A.Parameters.iron);
			printf("#SOIRON:%d\n",File1A.Parameters.soiron);
		}
		
		if(print_geoinfo == 1){
			printf("#Target:%s\n",File1A.GeoInfo.target);
			printf("#ShadowCone:%s\n",File1A.GeoInfo.shadowcone);
			printf("#SLitCenter:%f %f\n",File1A.GeoInfo.slitcenter[0],
				   File1A.GeoInfo.slitcenter[1]);
			printf("#SunLat:%f\n",File1A.GeoInfo.sunlat);
			printf("#SunLong:%f\n",File1A.GeoInfo.sunlong);
			printf("#SunDist:%f\n",File1A.GeoInfo.sundist);
			printf("#SunLS:%f\n",File1A.GeoInfo.sunls);
			printf("#SunRA:%f\n",File1A.GeoInfo.sunra);
			printf("#SunDEC:%f\n",File1A.GeoInfo.sundec);
		}
		
		// clean data
		if(print_cleandata == 1 && cleandata_sample != NULL){
			cleandata_arr_id = get_ArrSampleValues(cleandata_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			
			if(print_onlydata == 0)
				printf("#CleanData%s\n",cleandata_sample);
			
			print_data(cleandata_arr_id,File1A.cleandata,File1A.errdata,File1A.flag,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3,print_onlydata);
			
			//print min
			if(print_min == 1){
				if(print_onlydata == 0)
					printf("Minimum:%f\n",get_min(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
				else
					printf("%f\n",get_min(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
			}
			
			// print max
			if(print_max == 1){
				if(print_onlydata == 0)
					printf("Maximum:%f\n",get_max(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
				else
					printf("%f\n",get_max(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
			}
		}
				
		// Print only minimum on all cleandata
		if(print_min == 1 && print_cleandata == 1 && cleandata_sample == NULL){
			
			cleandata_arr_id = get_ArrSampleValues("[*,*,*]",File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			
			if(print_onlydata == 0)
				printf("Minimum:%f\n",get_min(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
			else
				printf("%f\n",get_min(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
		}
		
		// Print only maximum on all cleandata
		if(print_max == 1 && print_cleandata == 1 && cleandata_sample == NULL){
			
			cleandata_arr_id = get_ArrSampleValues("[*,*,*]",File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			
			if(print_onlydata == 0)
				printf("Maximum:%f\n",get_max(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
			else
				printf("%f\n",get_max(cleandata_arr_id,File1A.cleandata,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3));
		}
		
		
		// Print temperatures
		if(print_temperatures == 1){
			
			temperatures_arr_id = get_ArrSampleValues(temperatures_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_temperaturesdata(temperatures_arr_id,File1A.Parameters,File1A.Info.naxis2,print_onlydata);
		}
		
		// Print geometry
		if(georec_sample != NULL){
			if(0 == print_onlydata)
				printf("Number\tTime\n");
			georec_arr_id = get_ArrSampleValues(georec_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(georec_arr_id, File1A.Geo, File1A.Info.naxis2, 1);
		}
		if(geosc_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tsza\tshadowconeratio\n");
			geosc_arr_id = get_ArrSampleValues(geosc_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geosc_arr_id, File1A.Geo, File1A.Info.naxis2, 2);
		}
		if(geoband1_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tRA\tDEC\n");
			geoband1_arr_id = get_ArrSampleValues(geoband1_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geoband1_arr_id, File1A.Geo, File1A.Info.naxis2, 3);
		}
		if(geoband2_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tRA\tDEC\n");
			geoband2_arr_id = get_ArrSampleValues(geoband2_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geoband2_arr_id, File1A.Geo, File1A.Info.naxis2, 4);
		}
		if(geoband3_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tRA\tDEC\tsza\tdisttoplanetnp\tpixelsize\tanglelossun\tphaselossun\tsolarincidence\tsolarlocaltime\tanglenormalobserver\tsunazimuth\tdistlosplanetcenter\tdistscplanetcenter\n");
			geoband3_arr_id = get_ArrSampleValues(geoband3_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geoband3_arr_id, File1A.Geo, File1A.Info.naxis2, 5);
		}
		if(geoband4_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tRA\tDEC\n");
			geoband4_arr_id = get_ArrSampleValues(geoband4_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geoband4_arr_id, File1A.Geo, File1A.Info.naxis2, 6);
		}
		if(geoband5_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tRA\tDEC\n");
			geoband5_arr_id = get_ArrSampleValues(geoband5_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geoband5_arr_id, File1A.Geo, File1A.Info.naxis2, 7);
		}
		if(geocoord_sample != NULL){
			if(0 == print_onlydata)
				printf("xsc_x\txsc_y\txsc_z\tysc_x\tysc_y\tysc_z\tzsc_x\tzsc_y\tzsc_z\tangle_xsc_localvert\tangle_xsc_proj\tp1_u\tp1_v\tp2_u\tp2_v\tp3_u\tp3_v\tp4_u\tp4_v\tp5_u\tp5_v\n");
			geocoord_arr_id = get_ArrSampleValues(geocoord_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geocoord_arr_id, File1A.Geo, File1A.Info.naxis2, 8);
		}
		if(geotransm_sample != NULL){
			if(0 == print_onlydata)
				printf("x_ra\tx_dec\ty_ra\ty_dec\tz_ra\tz_dec\n");
			geotransm_arr_id = get_ArrSampleValues(geotransm_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geotransm_arr_id, File1A.Geo, File1A.Info.naxis2, 9);
		}
		if(geolose_sample != NULL){
			if(0 == print_onlydata)
				printf("Lat\tLong\tAlt\tRA\tDEC\tsza\tdisttoplanetnp\tpixelsize\tanglelossun\tphaselossun\tsolarincidence\tsolarlocaltime\tanglenormalobserver\tsunazimuth\tdistlosplanetcenter\tdistscplanetcenter\n");
			geolose_arr_id = get_ArrSampleValues(geolose_sample,File1A.Info.naxis1,File1A.Info.naxis2,File1A.Info.naxis3);
			print_geodata(geolose_arr_id, File1A.Geo, File1A.Info.naxis2, 10);
		}
	}
	/*
	 
	 int i;
	 for(i=100;i<200;i++){
	 printf("%f \n",File1A.Parameters.t_structure[i]);
	 }
	 
	 printf("%s \n",File1A.Geo.Record.time[1]);
	 printf("%d \n",File1A.Geo.Record.number[1]);
	 printf("%f \n",File1A.Geo.Spacecraft.lat[100]);
	 printf("%f \n",File1A.Geo.Spacecraft.lon[100]);
	 printf("%f \n",File1A.Geo.Spacecraft.alt[100]);
	 printf("%f \n",File1A.Geo.Spacecraft.sza[100]);
	 printf("%f \n",File1A.Geo.Spacecraft.shadowconeratio[100]);
	 
	 printf("%f \n",File1A.Geo.Band3.lat[0]);
	 */
	
	return 0;
}

float
get_min(int* data_arr_id, float **data, int naxis1, int naxis2, int naxis3)
{
	// Init for loop
	int iband = 0;
	int ispec = 0;
	int ipix = 0;
	int status = 0;
	
	float min_value = data[data_arr_id[2]][data_arr_id[0]+data_arr_id[1]*ispec];
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] < 0 || data_arr_id[3] < 0
		|| data_arr_id[1] < 0 || data_arr_id[4] < 0
		|| data_arr_id[2] < 0 || data_arr_id[5] < 0)
		status = 1;
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] >= naxis1 || data_arr_id[3] >= naxis1
		|| data_arr_id[1] >= naxis2 || data_arr_id[4] >= naxis2
		|| data_arr_id[2] >= naxis3 || data_arr_id[5] >= naxis3)
		status = 1;
	
	// Print between indices stored in data_arr_id
	if(0 == status){
		
		for(iband=data_arr_id[2];iband<data_arr_id[5]+1;iband++){
			for(ispec=data_arr_id[1];ispec<data_arr_id[4]+1;ispec++){
				for(ipix=data_arr_id[0];ipix<data_arr_id[3]+1;ipix++){
					
					// compare
					if(data[iband][ipix+naxis1*ispec] < min_value)
						min_value = data[iband][ipix+naxis1*ispec];
				}
			}
		}
	}
	else {
		printf("Array indices must be greater than 0 and lower than Naxis1, Naxis2 and Naxis3, check -i option results to get the axis values\n");
	}
	
	return(min_value);
}


float
get_max(int* data_arr_id, float **data, int naxis1, int naxis2, int naxis3)
{
	// Init for loop
	int iband = 0;
	int ispec = 0;
	int ipix = 0;
	int status = 0;
	
	float max_value = data[data_arr_id[2]][data_arr_id[0]+data_arr_id[1]*ispec];
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] < 0 || data_arr_id[3] < 0
		|| data_arr_id[1] < 0 || data_arr_id[4] < 0
		|| data_arr_id[2] < 0 || data_arr_id[5] < 0)
		status = 1;
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] >= naxis1 || data_arr_id[3] >= naxis1
		|| data_arr_id[1] >= naxis2 || data_arr_id[4] >= naxis2
		|| data_arr_id[2] >= naxis3 || data_arr_id[5] >= naxis3)
		status = 1;
	
	// Print between indices stored in data_arr_id
	if(0 == status){
		
		for(iband=data_arr_id[2];iband<data_arr_id[5]+1;iband++){
			for(ispec=data_arr_id[1];ispec<data_arr_id[4]+1;ispec++){
				for(ipix=data_arr_id[0];ipix<data_arr_id[3]+1;ipix++){
					
					// compare
					if(data[iband][ipix+naxis1*ispec] > max_value)
						max_value = data[iband][ipix+naxis1*ispec];
				}
			}
		}
	}
	else {
		printf("Array indices must be greater than 0 and lower than Naxis1, Naxis2 and Naxis3, check -i option results to get the axis values\n");
	}
	
	return(max_value);
}

void
print_data(int* data_arr_id, float **data,  float **errdata, int **flag, int naxis1, int naxis2, int naxis3, int print_onlydata)
{
	// Init for loop
	int iband = 0;
	int ispec = 0;
	int ipix = 0;
	int status = 0;
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] < 0 || data_arr_id[3] < 0
		|| data_arr_id[1] < 0 || data_arr_id[4] < 0
		|| data_arr_id[2] < 0 || data_arr_id[5] < 0)
		status = 1;
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] >= naxis1 || data_arr_id[3] >= naxis1
		|| data_arr_id[1] >= naxis2 || data_arr_id[4] >= naxis2
		|| data_arr_id[2] >= naxis3 || data_arr_id[5] >= naxis3)
		status = 1;
	
	// Print between indices stored in data_arr_id
	if(0 == status){
		
		// Print header
		if(0 == print_onlydata)
			printf("#Band\tSpec.\tPixel\tFlag\tInt.(ADU)\tError(ADU)\n");
		
		for(iband=data_arr_id[2];iband<data_arr_id[5]+1;iband++){
			for(ispec=data_arr_id[1];ispec<data_arr_id[4]+1;ispec++){
				for(ipix=data_arr_id[0];ipix<data_arr_id[3]+1;ipix++){
					
					// Print Band nb. Spec nb. Px nb.
					if(0 == print_onlydata)
						printf("%d\t%d\t%d\t%d\t%f\t%f\n",iband,ispec,ipix,flag[iband][ipix+naxis1*ispec],data[iband][ipix+naxis1*ispec],errdata[iband][ipix+naxis1*ispec]);
					else
						printf("%f\n",data[iband][ipix+naxis1*ispec]);
				}
			}
		}
	}
	else {
		printf("Array indices must be greater than 0 and lower than Naxis1, Naxis2 and Naxis3, check -i option results to get the axis values\n");
	}
}

void
print_temperaturesdata(int* data_arr_id, Parameters param, int naxis2, int print_onlydata)
{
	// Init for loop
	int status = 0;
	int i = 0;
	
	// In that function, we need only i0 and i3 of data_arr_id, the 2 values are the boundary values for Axis2 (spectrum)
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] < 0 || data_arr_id[3] < 0)
		status = 1;
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] >= naxis2 || data_arr_id[3] >= naxis2)
		status = 1;
	
	// Print between indices stored in data_arr_id
	if(0 == status){
		
		// Print header
		if(0 == print_onlydata)
			printf("Record\tAll_ti\tT_peltier\tT_ccd\tT_numboard\tT_btboard\tT_shutter\tT_servboard\tT_hvps\tT_structure\n");
		
		for(i=data_arr_id[0];i<data_arr_id[3]+1;i++)
			printf("%d\t%d\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",i,param.all_ti[i],param.t_peltier[i],param.t_ccd[i],
				   param.t_numboard[i],param.t_btboard[i],param.t_shutter[i],
				   param.t_servboard[i],param.t_hvps[i],param.t_structure[i]);
	}
	else {
		printf("Array indices must be greater than 0 and lower than Naxis1, Naxis2 and Naxis3, check -i option results to get the axis values\n");
	}
}

void
print_geodata(int* data_arr_id, Geo geo, int naxis2, int g)
{
	// Init for loop
	int status = 0;
	int i = 0;
	
	// In that function, we need only i0 and i3 of data_arr_id, the 2 values are the boundary values for Axis2 (spectrum)
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] < 0 || data_arr_id[3] < 0)
		status = 1;
	
	// Check if indices doesnt exceed values of axis
	if (	data_arr_id[0] >= naxis2 || data_arr_id[3] >= naxis2)
		status = 1;
	
	// Print between indices stored in data_arr_id
	if(0 == status){
		
		for(i=data_arr_id[0];i<data_arr_id[3]+1;i++){
			switch (g) {
				case 1:
					printf("%d\t%s\n",geo.Record.number[i],geo.Record.time[i]);
					break;
				case 2:
					printf("%f\t%f\t%f\t%f\t%f\n",geo.Spacecraft.lat[i],geo.Spacecraft.lon[i],geo.Spacecraft.alt[i],geo.Spacecraft.sza[i],geo.Spacecraft.shadowconeratio[i]);
					break;
				case 3:
					printf("%f\t%f\t%f\t%f\t%f\n",geo.Band1.lat[i],geo.Band1.lon[i],geo.Band1.alt[i],geo.Band1.ra[i],geo.Band1.dec[i]);
					break;
				case 4:
					printf("%f\t%f\t%f\t%f\t%f\n",geo.Band2.lat[i],geo.Band2.lon[i],geo.Band2.alt[i],geo.Band2.ra[i],geo.Band2.dec[i]);
					break;
				case 5:
					printf("%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",
						   geo.Band3.lat[i],geo.Band3.lon[i],geo.Band3.alt[i],geo.Band3.ra[i],geo.Band3.dec[i],geo.Band3.sza[i],geo.Band3.disttoplanetnp[i],
						   geo.Band3.pixelsize[i],geo.Band3.anglelossun[i],geo.Band3.phaselossun[i],geo.Band3.solarincidence[i],geo.Band3.solarlocaltime[i],
						   geo.Band3.anglenormalobserver[i],geo.Band3.sunazimuth[i],geo.Band3.distlosplanetcenter[i],geo.Band3.distscplanetcenter[i]);
					break;
				case 6:
					printf("%f\t%f\t%f\t%f\t%f\n",geo.Band4.lat[i],geo.Band4.lon[i],geo.Band4.alt[i],geo.Band4.ra[i],geo.Band4.dec[i]);
					break;
				case 7:
					printf("%f\t%f\t%f\t%f\t%f\n",geo.Band5.lat[i],geo.Band5.lon[i],geo.Band5.alt[i],geo.Band5.ra[i],geo.Band5.dec[i]);
					break;
				case 8:
					printf("%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",
						   geo.Coordinates.xsc_x[i],geo.Coordinates.xsc_y[i],geo.Coordinates.xsc_z[i],geo.Coordinates.ysc_x[i],geo.Coordinates.ysc_y[i],
						   geo.Coordinates.ysc_z[i],geo.Coordinates.zsc_x[i],geo.Coordinates.zsc_y[i],geo.Coordinates.zsc_z[i],geo.Coordinates.angle_xsc_localvert[i],
						   geo.Coordinates.angle_xsc_proj[i],geo.Coordinates.p1_u[i],geo.Coordinates.p1_v[i],geo.Coordinates.p2_u[i],geo.Coordinates.p2_v[i],
						   geo.Coordinates.p3_u[i],geo.Coordinates.p3_v[i],geo.Coordinates.p4_u[i],geo.Coordinates.p4_v[i],geo.Coordinates.p5_u[i],geo.Coordinates.p5_v[i]);
					break;
				case 9:
					printf("%f\t%f\t%f\t%f\t%f\t%f\n",
						   geo.TransMatrix.x_ra[i],geo.TransMatrix.x_dec[i],geo.TransMatrix.y_ra[i],geo.TransMatrix.y_dec[i],geo.TransMatrix.z_ra[i],geo.TransMatrix.z_dec[i]);
					break;
				case 10:
					printf("%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",
						   geo.LOSE.lat[i],geo.LOSE.lon[i],geo.LOSE.alt[i],geo.LOSE.ra[i],geo.LOSE.dec[i],geo.LOSE.sza[i],geo.LOSE.disttoplanetnp[i],geo.LOSE.pixelsize[i],
						   geo.LOSE.anglelossun[i],geo.LOSE.phaselossun[i],geo.LOSE.solarincidence[i],geo.LOSE.solarlocaltime[i],geo.LOSE.anglenormalobserver[i],
						   geo.LOSE.sunazimuth[i],geo.LOSE.distlosplanetcenter[i],geo.LOSE.distscplanetcenter[i]);
					break;
				default:
					break;
			}
		}
	}
	else {
		printf("Array indices must be greater than 0 and lower than Naxis1, Naxis2 and Naxis3, check -i option results to get the axis values\n");
	}
}

int*
get_ArrSampleValues(char *sample, int naxis1, int naxis2, int naxis3)
{
	// Init
	int* arr_id = (int *)malloc(6 * sizeof(int));
	int len = strlen(sample);
	char *str = (char *)malloc(len-2 * sizeof(char));
	char fmt_str[100] = "";
	
	// extract string between []
	snprintf(fmt_str, 100, "[%%%ds]", len-2);
	sscanf(sample,fmt_str,str);
	//printf("%s\n",str);
	
	// extract token
	int i = 0;
	char * pch;
	pch = strtok (str,",");
	while (pch != NULL)
	{
		// read token (int:int) or (int) with sscanf
		if (strchr(pch, ':') != NULL){
			sscanf(pch,"%d:%d",&arr_id[i],&arr_id[i+3]);
		}
		else {
			if (strcmp(pch,"*") == 0) {
				switch (i) {
					case 0:
						arr_id[i] = 0;
						arr_id[i+3] = naxis1-1;
						break;
					case 1:
						arr_id[i] = 0;
						arr_id[i+3] = naxis2-1;
						break;
					case 2:
						arr_id[i] = 0;
						arr_id[i+3] = naxis3-1;
						break;
					default:
						break;
				}
			}
			else {
				sscanf(pch,"%d",&arr_id[i]);
				arr_id[i+3]=arr_id[i];
			}
		}
		
		
		// increment
		i++;
		
		//continue
		pch = strtok (NULL, ",");
	}
	
	return(arr_id);
}


