program test

    !! Test program
    ! Definitions and declarations
    use spica_struct_1A
    integer i
    type(struc_1AFile) :: File1A
    character(len=2048) filename

    ! File to read:
    filename = '1A_Full_path'

    ! Read the 1A level, create the structture
    File1A = spica_read_1A(filename,1)

    !! Print some data
    print *, 'Observation parameters:'
    print *,File1A%Parameters%codeop
    print *,File1A%Parameters%binning
    print *,File1A%Parameters%ti
    print *,File1A%Parameters%ht
    print *,File1A%Parameters%x0
    print *,File1A%Parameters%y0
    print *,File1A%Parameters%slit
    print *,File1A%Parameters%peltier
    print *,File1A%Parameters%uvsampling
    print *,File1A%Parameters%iron
    print *,File1A%Parameters%soiron

    print *, '===== Observation information ====='
    print *,File1A%Info%DCProc
    print *,File1A%Info%ENProc
    print *,File1A%Info%SATProc
    print *,File1A%Info%COSProc
    print *,File1A%Info%File0C

    print *, '===== Temperatures sample ====='
    do, i=100,200
        print *, File1A%Parameters%t_structure(i)
    enddo

    print *, '===== Geometry information ====='
    print *,File1A%GeoInfo%target
    print *,File1A%GeoInfo%shadowcone
    print *,File1A%GeoInfo%slitcenter(1)
    print *,File1A%GeoInfo%slitcenter(2)
    print *,File1A%GeoInfo%sunlat
    print *,File1A%GeoInfo%sunlong
    print *,File1A%GeoInfo%sundist
    print *,File1A%GeoInfo%sunls
    print *,File1A%GeoInfo%sunra
    print *,File1A%GeoInfo%sundec

    print *, '===== Geometry records sample ====='
    print *,File1A%Geo%Record%time(1)
    print *,File1A%Geo%Record%number(1)

    print *, '===== Geometry of the spacecraft ====='
    print *,File1A%Geo%Spacecraft%lat(100)
    print *,File1A%Geo%Spacecraft%long(100)
    print *,File1A%Geo%Spacecraft%alt(100)
    print *,File1A%Geo%Spacecraft%sza(100)
    print *,File1A%Geo%Spacecraft%shadowconeratio(100)

    print *, '===== Data sample ====='
    print *,File1A%CleanData(101,100:200,1)

    print *, '===== Flag sample ====='
    print *,File1A%Flag(101,100:200,1)

    print *, '===== Error on correction sample ====='
    print *,File1A%ErrData(101,100:200,1)

end program test
